<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.6"/>
<title>TIML: timl.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIML
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.6 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_4f218e5c1c68a8760266841df915118e.html">src</a></li><li class="navelem"><a class="el" href="dir_e5def28db4ba0142cedf1af2d851f321.html">common</a></li><li class="navelem"><a class="el" href="dir_c5b36bb030c577d6bbefab4a3e5235f0.html">api</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">timl.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="timl_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef TIML_H_</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor"></span><span class="preprocessor">#define TIML_H_</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;</div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * modification, are permitted provided that the following conditions</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> * are met:</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *    Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *    documentation and/or other materials provided with the</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    distribution.</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    Neither the name of Texas Instruments Incorporated nor the names of</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *    its contributors may be used to endorse or promote products derived</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> *    from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"> * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"> * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"> * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"> * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"> * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"> * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="comment"> *  INCLUDES</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="timlUtil_8h.html">timlUtil.h</a>&quot;</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="timlCNN_8h.html">timlCNN.h</a>&quot;</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="comment"> *  DEFINITIONS</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="preprocessor">#define TIML_CPU</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="preprocessor"></span><span class="preprocessor">#ifndef TIML_CPU</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="preprocessor"></span><span class="preprocessor">#define TIML_ALT</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="preprocessor"></span><span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="comment"> * CNN PUBLIC FUNCTION PROTOTYPES</span></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="comment"> * DEFAULT PARAMS FUNCTIONS</span></div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<a class="code" href="structtimlCNNInputParams.html">timlCNNInputParams</a> <a class="code" href="group__cnn.html#ga71b91e772f1e63528e53a6284ba7b879">timlCNNInputParamsDefault</a>();</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<a class="code" href="structtimlCNNConvParams.html">timlCNNConvParams</a> <a class="code" href="group__cnn.html#ga33ddb7145ae4e19ea52e12576f4871aa">timlCNNConvParamsDefault</a>();</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<a class="code" href="structtimlCNNLinearParams.html">timlCNNLinearParams</a> <a class="code" href="group__cnn.html#gad5c8fd10f11ccaa8142a665fc8ee93b8">timlCNNLinearParamsDefault</a>();</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<a class="code" href="structtimlCNNPoolingParams.html">timlCNNPoolingParams</a> <a class="code" href="group__cnn.html#gacd163e268b3ccc9805bcca59689a36f5">timlCNNPoolingParamsDefault</a>();</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<a class="code" href="structtimlCNNNonlinearParams.html">timlCNNNonlinearParams</a> <a class="code" href="group__cnn.html#ga24aaf5f0c47a32c8223073f22c88c184">timlCNNNonlinearParamsDefault</a>();</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<a class="code" href="structtimlCNNNormParams.html">timlCNNNormParams</a> <a class="code" href="group__cnn.html#ga03ee34f7d893af02536bcbf2d071f721">timlCNNNormParamsDefault</a>();</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<a class="code" href="structtimlCNNTrainingParams.html">timlCNNTrainingParams</a> <a class="code" href="group__cnn.html#gaaf7a5b272ae2ba5d0453f214afaab747">timlCNNTrainingParamsDefault</a>();</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="comment"> * CNN SETUP FUNCTIONS</span></div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *<a class="code" href="group__cnn.html#gaf75b4687f4b493b8a85bc7fcc37bdf18">timlCNNCreateConvNeuralNetwork</a>(<a class="code" href="structtimlCNNTrainingParams.html">timlCNNTrainingParams</a> params, <span class="keywordtype">int</span> deviceId);</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#ga253033ab06b21f2bf28301bc1e53c419">timlCNNAddInputLayer</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <span class="keywordtype">int</span> featureMapRow, <span class="keywordtype">int</span> featureMapCol, <span class="keywordtype">int</span> featureMapChannel, <a class="code" href="structtimlCNNInputParams.html">timlCNNInputParams</a> params);</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#gab5dcc5ac470e15bea85f0a5570eec37d">timlCNNAddPoolingLayer</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <span class="keywordtype">int</span> scaleRow, <span class="keywordtype">int</span> scaleCol, <span class="keywordtype">int</span> strideX, <span class="keywordtype">int</span> strideY, timlCNNPoolingType type, <a class="code" href="structtimlCNNPoolingParams.html">timlCNNPoolingParams</a> params);</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#ga7627fe7a5294d7c8cac75d974b78a27a">timlCNNAddNormLayer</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <a class="code" href="structtimlCNNNormParams.html">timlCNNNormParams</a> params);</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#ga772bc4b21c2f800ee8ac5248a732f116">timlCNNAddConvLayer</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <span class="keywordtype">int</span> kernelRow, <span class="keywordtype">int</span> kernelCol, <span class="keywordtype">int</span> strideX, <span class="keywordtype">int</span> strideY, <span class="keywordtype">int</span> featureMapChannel, <a class="code" href="structtimlCNNConvParams.html">timlCNNConvParams</a> params);</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#gaddfd98d23613318bdc368eac98fddf0b">timlCNNAddNonlinearLayer</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, timlUtilActivationType type);</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#ga0219ba397301c5fb3eedfb64e62e33bc">timlCNNAddLinearLayer</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <span class="keywordtype">int</span> dim, <a class="code" href="structtimlCNNLinearParams.html">timlCNNLinearParams</a> params);</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#gae988ef172bde701db59b1cfc33dd50ab">timlCNNAddDropoutLayer</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <span class="keywordtype">float</span> prob);</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#ga666fa0a68b725aa1e35dba659ba7c5f9">timlCNNInitialize</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn);</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#ga21bc0c855cb658f51fe5d6911acddb54">timlCNNReset</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn);</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#ga5af48b599237f48f016ce2060c6053e1">timlCNNDelete</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn);</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="comment"> * CNN TRAINING AND TESTING FUNCTIONS</span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#ga9198f6379fad0e9e45dd8f64cc030ec3">timlCNNSupervisedTrainingWithLabelBatchMode</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <span class="keywordtype">float</span> *data, <span class="keywordtype">int</span> *label, <span class="keywordtype">int</span> dim, <span class="keywordtype">int</span> num);</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#ga8b59ecbca36e54cfa1df0766ece686b5">timlCNNClassifyTopNBatchMode</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <span class="keywordtype">float</span> *data, <span class="keywordtype">int</span> dim, <span class="keywordtype">int</span> num, <span class="keywordtype">int</span> *label, <span class="keywordtype">float</span> *percent, <span class="keywordtype">int</span> topN);</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#gafda5077b0d39c278469278b37f845aed">timlCNNClassifyTop1SingleMode</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <span class="keywordtype">float</span> *data, <span class="keywordtype">int</span> dim);</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#ga04d9a7e3725ce777402e1e5c4d5d4ce0">timlCNNSetMode</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, timlUtilPhase phase);</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;<span class="comment"> * CNN AUX FUNCTIONS</span></div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a>* <a class="code" href="group__cnn.html#ga409c28e6bb3633f1de65647b790aa320">timlCNNClone</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <span class="keywordtype">int</span> deviceId);</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a>* <a class="code" href="group__cnn.html#ga52826c14f9f1913947f5ca6937b5afd5">timlCNNShareParams</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <span class="keywordtype">int</span> deviceId);</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;<span class="keywordtype">long</span> <a class="code" href="group__cnn.html#ga2e8a7e765f885a236e40dfaed59913c6">timlCNNMemory</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn);</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;<span class="keywordtype">long</span> <a class="code" href="group__cnn.html#ga72df82405eb43be8bb75373aaf8ec101">timlCNNGetParamsNum</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn);</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#gad7f3f988c763fe5a80826439c9fb08bd">timlCNNWriteToFile</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> * fileName, <a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <a class="code" href="group__util.html#ga8e44b2a87636024736da04ae5a53c1c9">timlUtilParamsLevel</a> paramsLevel, <span class="keyword">const</span> <span class="keywordtype">char</span>* name, <span class="keyword">const</span> <span class="keywordtype">char</span> *floatFormat, <span class="keyword">const</span> <span class="keywordtype">char</span> *intFormat);</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a>* <a class="code" href="group__cnn.html#gabab7c3c18a2fa4a3a9985da42662682c">timlCNNReadFromFile</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> * fileName, <span class="keywordtype">int</span> deviceId);</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#ga123557b8025497fe266d58d80ee9983b">timlCNNPrint</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn);</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#ga13c723ecb589f7da7e01a9cd9591061d">timlCNNProfile</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <span class="keywordtype">float</span> *data, <span class="keywordtype">int</span> dim, <span class="keywordtype">int</span> num, <span class="keywordtype">int</span> *label, <span class="keywordtype">int</span> iter);</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#ga78addba765ea7dd8bf958d19d42be931">timlCNNResize</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <span class="keywordtype">int</span> row, <span class="keywordtype">int</span> col, <span class="keywordtype">int</span> channel);</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#gaf65f8d45c892f70eeee34b47791bdcb5">timlCNNGetLayerNum</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn);</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__cnn.html#ga78addba765ea7dd8bf958d19d42be931">timlCNNResize</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <span class="keywordtype">int</span> row, <span class="keywordtype">int</span> col, <span class="keywordtype">int</span> channel);</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="ttc" id="group__cnn_html_gacd163e268b3ccc9805bcca59689a36f5"><div class="ttname"><a href="group__cnn.html#gacd163e268b3ccc9805bcca59689a36f5">timlCNNPoolingParamsDefault</a></div><div class="ttdeci">timlCNNPoolingParams timlCNNPoolingParamsDefault()</div><div class="ttdoc">Return the default parameters for the pooling layer. </div><div class="ttdef"><b>Definition:</b> timlCNNPoolingParamsDefault.c:55</div></div>
<div class="ttc" id="group__cnn_html_ga666fa0a68b725aa1e35dba659ba7c5f9"><div class="ttname"><a href="group__cnn.html#ga666fa0a68b725aa1e35dba659ba7c5f9">timlCNNInitialize</a></div><div class="ttdeci">int timlCNNInitialize(timlConvNeuralNetwork *cnn)</div><div class="ttdoc">Allocate the memory required by the cnn. </div><div class="ttdef"><b>Definition:</b> timlCNNInitialize.c:56</div></div>
<div class="ttc" id="group__cnn_html_ga04d9a7e3725ce777402e1e5c4d5d4ce0"><div class="ttname"><a href="group__cnn.html#ga04d9a7e3725ce777402e1e5c4d5d4ce0">timlCNNSetMode</a></div><div class="ttdeci">int timlCNNSetMode(timlConvNeuralNetwork *cnn, timlUtilPhase phase)</div><div class="ttdoc">Set the phase (train/test) of the cnn. </div><div class="ttdef"><b>Definition:</b> timlCNNSetMode.c:56</div></div>
<div class="ttc" id="group__cnn_html_gaaf7a5b272ae2ba5d0453f214afaab747"><div class="ttname"><a href="group__cnn.html#gaaf7a5b272ae2ba5d0453f214afaab747">timlCNNTrainingParamsDefault</a></div><div class="ttdeci">timlCNNTrainingParams timlCNNTrainingParamsDefault()</div><div class="ttdoc">Return the default training parameters. </div><div class="ttdef"><b>Definition:</b> timlCNNTrainingParamsDefault.c:55</div></div>
<div class="ttc" id="group__cnn_html_gaf75b4687f4b493b8a85bc7fcc37bdf18"><div class="ttname"><a href="group__cnn.html#gaf75b4687f4b493b8a85bc7fcc37bdf18">timlCNNCreateConvNeuralNetwork</a></div><div class="ttdeci">timlConvNeuralNetwork * timlCNNCreateConvNeuralNetwork(timlCNNTrainingParams params, int deviceId)</div><div class="ttdoc">Create a cnn structure. </div><div class="ttdef"><b>Definition:</b> timlCNNCreateConvNeuralNetwork.c:57</div></div>
<div class="ttc" id="group__cnn_html_ga24aaf5f0c47a32c8223073f22c88c184"><div class="ttname"><a href="group__cnn.html#ga24aaf5f0c47a32c8223073f22c88c184">timlCNNNonlinearParamsDefault</a></div><div class="ttdeci">timlCNNNonlinearParams timlCNNNonlinearParamsDefault()</div><div class="ttdoc">Return the default parameters for the nonlinear layer. </div><div class="ttdef"><b>Definition:</b> timlCNNNonlinearParamsDefault.c:55</div></div>
<div class="ttc" id="group__util_html_ga8e44b2a87636024736da04ae5a53c1c9"><div class="ttname"><a href="group__util.html#ga8e44b2a87636024736da04ae5a53c1c9">timlUtilParamsLevel</a></div><div class="ttdeci">timlUtilParamsLevel</div><div class="ttdef"><b>Definition:</b> timlUtil.h:132</div></div>
<div class="ttc" id="group__cnn_html_ga8b59ecbca36e54cfa1df0766ece686b5"><div class="ttname"><a href="group__cnn.html#ga8b59ecbca36e54cfa1df0766ece686b5">timlCNNClassifyTopNBatchMode</a></div><div class="ttdeci">int timlCNNClassifyTopNBatchMode(timlConvNeuralNetwork *cnn, float *data, int dim, int num, int *label, float *percent, int topN)</div><div class="ttdoc">Batch classification. </div><div class="ttdef"><b>Definition:</b> timlCNNClassifyTopNBatchMode.c:62</div></div>
<div class="ttc" id="structtimlCNNNormParams_html"><div class="ttname"><a href="structtimlCNNNormParams.html">timlCNNNormParams</a></div><div class="ttdef"><b>Definition:</b> timlCNN.h:193</div></div>
<div class="ttc" id="struct__timlConvNeuralNetwork___html"><div class="ttname"><a href="struct__timlConvNeuralNetwork__.html">_timlConvNeuralNetwork_</a></div><div class="ttdef"><b>Definition:</b> timlCNN.h:257</div></div>
<div class="ttc" id="structtimlCNNLinearParams_html"><div class="ttname"><a href="structtimlCNNLinearParams.html">timlCNNLinearParams</a></div><div class="ttdef"><b>Definition:</b> timlCNN.h:132</div></div>
<div class="ttc" id="group__cnn_html_ga52826c14f9f1913947f5ca6937b5afd5"><div class="ttname"><a href="group__cnn.html#ga52826c14f9f1913947f5ca6937b5afd5">timlCNNShareParams</a></div><div class="ttdeci">timlConvNeuralNetwork * timlCNNShareParams(timlConvNeuralNetwork *cnn, int deviceId)</div><div class="ttdoc">Create a new CNN that shares the parameters with the input CNN. </div><div class="ttdef"><b>Definition:</b> timlCNNShareParams.c:59</div></div>
<div class="ttc" id="group__cnn_html_ga9198f6379fad0e9e45dd8f64cc030ec3"><div class="ttname"><a href="group__cnn.html#ga9198f6379fad0e9e45dd8f64cc030ec3">timlCNNSupervisedTrainingWithLabelBatchMode</a></div><div class="ttdeci">int timlCNNSupervisedTrainingWithLabelBatchMode(timlConvNeuralNetwork *cnn, float *data, int *label, int dim, int num)</div><div class="ttdoc">Supervised training with label. </div><div class="ttdef"><b>Definition:</b> timlCNNSupervisedTrainingWithLabelBatchMode.c:60</div></div>
<div class="ttc" id="timlCNN_8h_html"><div class="ttname"><a href="timlCNN_8h.html">timlCNN.h</a></div></div>
<div class="ttc" id="group__cnn_html_ga772bc4b21c2f800ee8ac5248a732f116"><div class="ttname"><a href="group__cnn.html#ga772bc4b21c2f800ee8ac5248a732f116">timlCNNAddConvLayer</a></div><div class="ttdeci">int timlCNNAddConvLayer(timlConvNeuralNetwork *cnn, int kernelRow, int kernelCol, int strideX, int strideY, int featureMapChannel, timlCNNConvParams params)</div><div class="ttdoc">Add conv layer. </div><div class="ttdef"><b>Definition:</b> timlCNNAddConvLayer.c:62</div></div>
<div class="ttc" id="group__cnn_html_ga409c28e6bb3633f1de65647b790aa320"><div class="ttname"><a href="group__cnn.html#ga409c28e6bb3633f1de65647b790aa320">timlCNNClone</a></div><div class="ttdeci">timlConvNeuralNetwork * timlCNNClone(timlConvNeuralNetwork *cnn, int deviceId)</div><div class="ttdoc">Clone a cnn. </div><div class="ttdef"><b>Definition:</b> timlCNNClone.c:57</div></div>
<div class="ttc" id="group__cnn_html_ga03ee34f7d893af02536bcbf2d071f721"><div class="ttname"><a href="group__cnn.html#ga03ee34f7d893af02536bcbf2d071f721">timlCNNNormParamsDefault</a></div><div class="ttdeci">timlCNNNormParams timlCNNNormParamsDefault()</div><div class="ttdoc">Return the default parameters for the norm layer. </div><div class="ttdef"><b>Definition:</b> timlCNNNormParamsDefault.c:55</div></div>
<div class="ttc" id="structtimlCNNTrainingParams_html"><div class="ttname"><a href="structtimlCNNTrainingParams.html">timlCNNTrainingParams</a></div><div class="ttdef"><b>Definition:</b> timlCNN.h:244</div></div>
<div class="ttc" id="group__cnn_html_gaf65f8d45c892f70eeee34b47791bdcb5"><div class="ttname"><a href="group__cnn.html#gaf65f8d45c892f70eeee34b47791bdcb5">timlCNNGetLayerNum</a></div><div class="ttdeci">int timlCNNGetLayerNum(timlConvNeuralNetwork *cnn)</div><div class="ttdoc">Return the number of layers of the cnn. </div><div class="ttdef"><b>Definition:</b> timlCNNGetLayerNum.c:56</div></div>
<div class="ttc" id="timlUtil_8h_html"><div class="ttname"><a href="timlUtil_8h.html">timlUtil.h</a></div></div>
<div class="ttc" id="group__cnn_html_ga13c723ecb589f7da7e01a9cd9591061d"><div class="ttname"><a href="group__cnn.html#ga13c723ecb589f7da7e01a9cd9591061d">timlCNNProfile</a></div><div class="ttdeci">int timlCNNProfile(timlConvNeuralNetwork *cnn, float *data, int dim, int num, int *label, int iter)</div><div class="ttdoc">Profile the CNN with both timing and memory allocation. </div><div class="ttdef"><b>Definition:</b> timlCNNProfile.c:61</div></div>
<div class="ttc" id="structtimlCNNConvParams_html"><div class="ttname"><a href="structtimlCNNConvParams.html">timlCNNConvParams</a></div><div class="ttdef"><b>Definition:</b> timlCNN.h:158</div></div>
<div class="ttc" id="group__cnn_html_gab5dcc5ac470e15bea85f0a5570eec37d"><div class="ttname"><a href="group__cnn.html#gab5dcc5ac470e15bea85f0a5570eec37d">timlCNNAddPoolingLayer</a></div><div class="ttdeci">int timlCNNAddPoolingLayer(timlConvNeuralNetwork *cnn, int scaleRow, int scaleCol, int strideX, int strideY, timlCNNPoolingType type, timlCNNPoolingParams params)</div><div class="ttdoc">Add pooling layer. </div><div class="ttdef"><b>Definition:</b> timlCNNAddPoolingLayer.c:62</div></div>
<div class="ttc" id="group__cnn_html_ga33ddb7145ae4e19ea52e12576f4871aa"><div class="ttname"><a href="group__cnn.html#ga33ddb7145ae4e19ea52e12576f4871aa">timlCNNConvParamsDefault</a></div><div class="ttdeci">timlCNNConvParams timlCNNConvParamsDefault()</div><div class="ttdoc">Return the default parameters for the convolutional layer. </div><div class="ttdef"><b>Definition:</b> timlCNNConvParamsDefault.c:55</div></div>
<div class="ttc" id="group__cnn_html_gabab7c3c18a2fa4a3a9985da42662682c"><div class="ttname"><a href="group__cnn.html#gabab7c3c18a2fa4a3a9985da42662682c">timlCNNReadFromFile</a></div><div class="ttdeci">timlConvNeuralNetwork * timlCNNReadFromFile(const char *fileName, int deviceId)</div><div class="ttdoc">Read CNN from file(s) </div><div class="ttdef"><b>Definition:</b> timlCNNReadFromFile.c:57</div></div>
<div class="ttc" id="group__cnn_html_ga0219ba397301c5fb3eedfb64e62e33bc"><div class="ttname"><a href="group__cnn.html#ga0219ba397301c5fb3eedfb64e62e33bc">timlCNNAddLinearLayer</a></div><div class="ttdeci">int timlCNNAddLinearLayer(timlConvNeuralNetwork *cnn, int dim, timlCNNLinearParams params)</div><div class="ttdoc">Add linear layer. </div><div class="ttdef"><b>Definition:</b> timlCNNAddLinearLayer.c:58</div></div>
<div class="ttc" id="group__cnn_html_ga72df82405eb43be8bb75373aaf8ec101"><div class="ttname"><a href="group__cnn.html#ga72df82405eb43be8bb75373aaf8ec101">timlCNNGetParamsNum</a></div><div class="ttdeci">long timlCNNGetParamsNum(timlConvNeuralNetwork *cnn)</div><div class="ttdoc">Get the number of parameters of the cnn. </div><div class="ttdef"><b>Definition:</b> timlCNNGetParamsNum.c:55</div></div>
<div class="ttc" id="group__cnn_html_ga253033ab06b21f2bf28301bc1e53c419"><div class="ttname"><a href="group__cnn.html#ga253033ab06b21f2bf28301bc1e53c419">timlCNNAddInputLayer</a></div><div class="ttdeci">int timlCNNAddInputLayer(timlConvNeuralNetwork *cnn, int featureMapRow, int featureMapCol, int featureMapChannel, timlCNNInputParams params)</div><div class="ttdoc">Add input layer. </div><div class="ttdef"><b>Definition:</b> timlCNNAddInputLayer.c:60</div></div>
<div class="ttc" id="group__cnn_html_ga5af48b599237f48f016ce2060c6053e1"><div class="ttname"><a href="group__cnn.html#ga5af48b599237f48f016ce2060c6053e1">timlCNNDelete</a></div><div class="ttdeci">int timlCNNDelete(timlConvNeuralNetwork *cnn)</div><div class="ttdoc">Free a cnn structure. </div><div class="ttdef"><b>Definition:</b> timlCNNDelete.c:56</div></div>
<div class="ttc" id="group__cnn_html_ga7627fe7a5294d7c8cac75d974b78a27a"><div class="ttname"><a href="group__cnn.html#ga7627fe7a5294d7c8cac75d974b78a27a">timlCNNAddNormLayer</a></div><div class="ttdeci">int timlCNNAddNormLayer(timlConvNeuralNetwork *cnn, timlCNNNormParams params)</div><div class="ttdoc">Add normalization layer. </div><div class="ttdef"><b>Definition:</b> timlCNNAddNormLayer.c:57</div></div>
<div class="ttc" id="structtimlCNNPoolingParams_html"><div class="ttname"><a href="structtimlCNNPoolingParams.html">timlCNNPoolingParams</a></div><div class="ttdef"><b>Definition:</b> timlCNN.h:119</div></div>
<div class="ttc" id="structtimlCNNNonlinearParams_html"><div class="ttname"><a href="structtimlCNNNonlinearParams.html">timlCNNNonlinearParams</a></div><div class="ttdef"><b>Definition:</b> timlCNN.h:188</div></div>
<div class="ttc" id="group__cnn_html_ga123557b8025497fe266d58d80ee9983b"><div class="ttname"><a href="group__cnn.html#ga123557b8025497fe266d58d80ee9983b">timlCNNPrint</a></div><div class="ttdeci">int timlCNNPrint(timlConvNeuralNetwork *cnn)</div><div class="ttdoc">Print out the information of the cnn. </div><div class="ttdef"><b>Definition:</b> timlCNNPrint.c:56</div></div>
<div class="ttc" id="group__cnn_html_ga78addba765ea7dd8bf958d19d42be931"><div class="ttname"><a href="group__cnn.html#ga78addba765ea7dd8bf958d19d42be931">timlCNNResize</a></div><div class="ttdeci">int timlCNNResize(timlConvNeuralNetwork *cnn, int row, int col, int channel)</div><div class="ttdoc">Resize the feature map sizes to accommodate new input feature map dimensions. </div><div class="ttdef"><b>Definition:</b> timlCNNResize.c:60</div></div>
<div class="ttc" id="group__cnn_html_gad5c8fd10f11ccaa8142a665fc8ee93b8"><div class="ttname"><a href="group__cnn.html#gad5c8fd10f11ccaa8142a665fc8ee93b8">timlCNNLinearParamsDefault</a></div><div class="ttdeci">timlCNNLinearParams timlCNNLinearParamsDefault()</div><div class="ttdoc">Return the default parameters for the linear layer. </div><div class="ttdef"><b>Definition:</b> timlCNNLinearParamsDefault.c:54</div></div>
<div class="ttc" id="group__cnn_html_ga71b91e772f1e63528e53a6284ba7b879"><div class="ttname"><a href="group__cnn.html#ga71b91e772f1e63528e53a6284ba7b879">timlCNNInputParamsDefault</a></div><div class="ttdeci">timlCNNInputParams timlCNNInputParamsDefault()</div><div class="ttdoc">Return the default parameters for the input layer. </div><div class="ttdef"><b>Definition:</b> timlCNNInputParamsDefault.c:55</div></div>
<div class="ttc" id="structtimlCNNInputParams_html"><div class="ttname"><a href="structtimlCNNInputParams.html">timlCNNInputParams</a></div><div class="ttdef"><b>Definition:</b> timlCNN.h:201</div></div>
<div class="ttc" id="group__cnn_html_gae988ef172bde701db59b1cfc33dd50ab"><div class="ttname"><a href="group__cnn.html#gae988ef172bde701db59b1cfc33dd50ab">timlCNNAddDropoutLayer</a></div><div class="ttdeci">int timlCNNAddDropoutLayer(timlConvNeuralNetwork *cnn, float prob)</div><div class="ttdoc">Add dropout layer. </div><div class="ttdef"><b>Definition:</b> timlCNNAddDropoutLayer.c:57</div></div>
<div class="ttc" id="group__cnn_html_gafda5077b0d39c278469278b37f845aed"><div class="ttname"><a href="group__cnn.html#gafda5077b0d39c278469278b37f845aed">timlCNNClassifyTop1SingleMode</a></div><div class="ttdeci">int timlCNNClassifyTop1SingleMode(timlConvNeuralNetwork *cnn, float *data, int dim)</div><div class="ttdoc">Classify the data. </div><div class="ttdef"><b>Definition:</b> timlCNNClassifyTop1SingleMode.c:58</div></div>
<div class="ttc" id="group__cnn_html_gad7f3f988c763fe5a80826439c9fb08bd"><div class="ttname"><a href="group__cnn.html#gad7f3f988c763fe5a80826439c9fb08bd">timlCNNWriteToFile</a></div><div class="ttdeci">int timlCNNWriteToFile(const char *fileName, timlConvNeuralNetwork *cnn, timlUtilParamsLevel paramsLevel, const char *name, const char *floatFormat, const char *intFormat)</div><div class="ttdoc">Write the cnn to file(s) </div><div class="ttdef"><b>Definition:</b> timlCNNWriteToFile.c:61</div></div>
<div class="ttc" id="group__cnn_html_ga21bc0c855cb658f51fe5d6911acddb54"><div class="ttname"><a href="group__cnn.html#ga21bc0c855cb658f51fe5d6911acddb54">timlCNNReset</a></div><div class="ttdeci">int timlCNNReset(timlConvNeuralNetwork *cnn)</div><div class="ttdoc">Reset the parameters of the CNN. </div><div class="ttdef"><b>Definition:</b> timlCNNReset.c:56</div></div>
<div class="ttc" id="group__cnn_html_ga2e8a7e765f885a236e40dfaed59913c6"><div class="ttname"><a href="group__cnn.html#ga2e8a7e765f885a236e40dfaed59913c6">timlCNNMemory</a></div><div class="ttdeci">long timlCNNMemory(timlConvNeuralNetwork *cnn)</div><div class="ttdoc">Return the memory in bytes required by the cnn. </div><div class="ttdef"><b>Definition:</b> timlCNNMemory.c:56</div></div>
<div class="ttc" id="group__cnn_html_gaddfd98d23613318bdc368eac98fddf0b"><div class="ttname"><a href="group__cnn.html#gaddfd98d23613318bdc368eac98fddf0b">timlCNNAddNonlinearLayer</a></div><div class="ttdeci">int timlCNNAddNonlinearLayer(timlConvNeuralNetwork *cnn, timlUtilActivationType type)</div><div class="ttdoc">Add nonlinear layer. </div><div class="ttdef"><b>Definition:</b> timlCNNAddNonlinearLayer.c:57</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Mar 20 2015 11:26:08 for TIML by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.6
</small></address>
</body>
</html>
